/* io_lpf.h */
/* pararell port access utility for FreeBSD */
/* $Id: io_lpf.h,v 1.1 2000/02/12 01:17:40 jm3wud Exp jm3wud $ */

#ifndef IO_LP_H
#define IO_LP_H

/* #include <asm/io.h> */
#include <machine/cpufunc.h>
#include <unistd.h>
#include <errno.h>

/* I/O port address */
#define LP_DATA_REG    0x378
#define LP_STATUS_REG  0x379
#define LP_CONTROL_REG 0x37a

/* status regs */
#define LP_BUSY        (1 << 7)
#define LP_N_ACK       (1 << 6)
#define LP_PE          (1 << 5)
#define LP_SELECT      (1 << 4)
#define LP_ERROR       (1 << 3)

/* control regs */
#define LP_IO          (1 << 5)
#define LP_INT         (1 << 4)
#define LP_N_SLCTIN    (1 << 3)
#define LP_N_INIT      (1 << 2)
#define LP_AUTOFD      (1 << 1)
#define LP_N_STROBE    (1)

/* LP access macros */
#define LP_INIT(turn_on)

#define LP_WRITE_CONTROL(byte) outb(LP_CONTROL_REG, byte)
#define LP_READ_STATUS() inb(LP_STATUS_REG)
#if DEBUG_DRY
#define LP_WRITE_DATA(byte) outb(LP_DATA_REG, byte),fprintf(stdout, "%d%d%d%d%d%d%d%d\n", (((byte)&0x80)!=0),(((byte)&0x40)!=0),(((byte)&0x20)!=0),(((byte)&0x10)!=0),(((byte)&0x08)!=0),(((byte)&0x04)!=0),(((byte)&0x02)!=0),(((byte)&0x01)!=0))
#else
#define LP_WRITE_DATA(byte) outb(LP_DATA_REG, byte)
#endif
#define LP_READ_DATA() inb(LP_DATA_REG)

#endif /* IO_LP_H */
