/* pic_db.h */
/* pic data base */

#ifndef PIC_DB_H
#define PIC_DB_H

#define PIC16C84 0
#define PIC16F84 1
#define PIC12C509 2

struct pic_t {
  int prog_size;   /* size of program memory */
  int id_loc;      /* location of ID area */
  int fuse_loc;    /* where fuse? */
  int data_size;   /* size of data memory */
  int sizeof_progword; /* bit length of 1-word of program memory */
  int sizeof_dataword; /* bit length of 1-word of data memory */
};

#define DATA_FROM 0x2100   /* Where Assembler locate EEPROM data from ... */

#if MAIN

struct pic_t PIC_DB[] = {
  {1024, 0x2000, 0x2007, 64, 14, 8},
  {1024, 0x2000, 0x2007, 64, 14, 8},
  {1024, 1024, 0xfff, 0, 12, 8}
};

static char rcsid_pic_db_h[] = "$Id: pic_db.h,v 1.3 1997/12/28 15:23:13 kondou Exp kondou $";

# else /* MAIN */

extern struct pic_t PIC_DB[];

#endif /* MAIN */

#endif /* PIC_DB_H */
