/* writer.h */
/* pic writer library */
/* $Id: writer.h,v 1.4 1997/12/31 04:51:46 kondou Exp kondou $ */

#define LP_PIC_DATA        (1 << 0)
#define LP_PIC_CLK         (1 << 1)
#define LP_PIC_DATA_ENABLE (1 << 2)
#define LP_PIC_MCLR_1      (1 << 3)
#define LP_PIC_MCLR_2      (1 << 4)
#define LP_PIC_CLK_ENABLE  (1 << 5)
#ifndef USE_BUSY
#define LP_PIC_DATA_READ   LP_N_ACK
#else
#define LP_PIC_DATA_READ   LP_BUSY
#endif

#define UP 1
#define DOWN 0
#define ON 1
#define OFF 0

#define PIC_CMD_LOAD_CONFIG    0x00
#define PIC_CMD_LOAD_PROG      0x02
#define PIC_CMD_READ_PROG      0x04
#define PIC_CMD_INCR_ADDR      0x06
#define PIC_CMD_BEGIN_PROG     0x08
#define PIC_CMD_BULK_ERASE_PROG 0x09
#define PIC_CMD_ENTER_PARALLEL 0x0a
#define PIC_CMD_BULK_ERASE_DATA 0x0b
#define PIC_CMD_LOAD_DATA      0x03
#define PIC_CMD_READ_DATA      0x05

/* for lp_pic_mclr */
#define PIC_MCLR_VDD   0x00
#define PIC_MCLR_VPP   LP_PIC_MCLR_1
#define PIC_MCLR_ZERO  LP_PIC_MCLR_2

/* for p_or_m */
#define PROGRAM_MEMORY 0
#define DATA_MEMORY 1

int lp_pic_modify(int *port, int bit, int data);
void lp_pic_clock(int *port, int data);
void lp_pic_data_out(int *port, int data);
int lp_pic_data_in(int *port);
void lp_pic_mclr(int *port, int cmd);
void send_sign(int *port, int data);
void load_cycle(int *port, int data, int cmd, int pic_type);
int read_cycle(int *port, int cmd, int pic_type);
void prog_verify_mode(int *port, int on);
void pic_write(int *port, int p_or_m, unsigned short *data,
			   int len, int pic_type);
void pic_read(int *port, int p_or_m, unsigned short *data,
			  int len, int pic_type);
void pic_write_fuse(int *port, unsigned short data, int pic_type);
void pic_chip_erase(int *port, int pic_type);
void pic_wait_setup(void);
void pic_wait(int microseconds);
